Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 955)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 957)
@@ -451,5 +451,5 @@
 	}
 	// weight
-	nn->f1 = GenoOperators::mutateNeuProperty(nn->f1, NULL, -1);
+	nn->f1 = GenoOperators::mutateNeuronProperty(nn->f1, NULL, -1);
 	//nn->f1 = 10.0f * (rndDouble(1) - 0.5f);
 }
@@ -488,5 +488,5 @@
 		break;
 	case 2: // change weight
-		nn->f1 = GenoOperators::mutateNeuProperty(nn->f1, NULL, -1);
+		nn->f1 = GenoOperators::mutateNeuronProperty(nn->f1, NULL, -1);
 		//nn->f1 += 1.0f * (rndDouble(1) - 0.5f);
 		break;
Index: cpp/frams/genetics/fH/fH_oper.cpp
===================================================================
--- cpp/frams/genetics/fH/fH_oper.cpp	(revision 955)
+++ cpp/frams/genetics/fH/fH_oper.cpp	(revision 957)
@@ -390,5 +390,5 @@
 			// if it is weight, then method needs to use mutateNeuProperty
 			double current = par.getDouble(id);
-			par.setDouble(id, mutateNeuProperty(current, NULL, -1));
+			par.setDouble(id, mutateNeuronProperty(current, NULL, -1));
 		}
 	}
@@ -439,5 +439,5 @@
 		if (*par.type(i) == 'f')
 		{
-			double change = mutateNeuProperty(par.getDouble(i), &neu, 100 + i);
+			double change = mutateNeuronProperty(par.getDouble(i), &neu, GenoOperators::NEUROCLASS_PROP_OFFSET + i);
 			par.setDouble(i, change);
 		}
@@ -467,5 +467,5 @@
 	{
 		nc = getRandomNeuroClass(Model::SHAPE_BALL_AND_STICK);
-		// checking of neuron class availability should be checked before
+		// checking of neuron class availability should be done before
 	}
 
Index: cpp/frams/genetics/genooperators.cpp
===================================================================
--- cpp/frams/genetics/genooperators.cpp	(revision 955)
+++ cpp/frams/genetics/genooperators.cpp	(revision 957)
@@ -76,5 +76,5 @@
 }
 
-int GenoOperators::selectRandomNeuProperty(Neuro *n)
+int GenoOperators::selectRandomNeuronProperty(Neuro *n)
 {
 	int neuext = n->extraProperties().getPropCount(),
@@ -82,13 +82,13 @@
 	if (neuext + neucls == 0) return -1; //no properties in this neuron
 	int index = rndUint(neuext + neucls);
-	if (index >= neuext) index = index - neuext + 100;
+	if (index >= neuext) index = index - neuext + NEUROCLASS_PROP_OFFSET;
 	return index;
 }
 
-double GenoOperators::mutateNeuProperty(double current, Neuro *n, int i)
+double GenoOperators::mutateNeuronProperty(double current, Neuro *n, int i)
 {
 	if (i == -1) return mutateCreepNoLimit('f', current, 2, true); //i==-1: mutating weight of neural connection
 	Param p;
-	if (i >= 100) { i -= 100; p = n->getClass()->getProperties(); }
+	if (i >= NEUROCLASS_PROP_OFFSET) { i -= NEUROCLASS_PROP_OFFSET; p = n->getClass()->getProperties(); }
 	else p = n->extraProperties();
 	double newval = current;
@@ -354,5 +354,5 @@
 			const char *n = p.id(i);
 			int l = (int)strlen(n);
-			if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = 100 + i; Len = l; }
+			if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = NEUROCLASS_PROP_OFFSET + i; Len = l; }
 			if (also_v1_N_props) //recognize old properties symbols /=!
 			{
@@ -361,5 +361,5 @@
 						if (strcmp(n, "fo") == 0) n = "!";
 				l = (int)strlen(n);
-				if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = 100 + i; Len = l; }
+				if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = NEUROCLASS_PROP_OFFSET + i; Len = l; }
 			}
 		}
Index: cpp/frams/genetics/genooperators.h
===================================================================
--- cpp/frams/genetics/genooperators.h	(revision 955)
+++ cpp/frams/genetics/genooperators.h	(revision 957)
@@ -180,8 +180,11 @@
 	/** \name Some helpful methods for you */
 	//@{
+
+	static const int NEUROCLASS_PROP_OFFSET = 100; //a property is identified by some functions below as a single-value integer index, yet a property concerns either a Neuron or a NeuroClass, hence this offset to tell one case from the other.
+
 	static int roulette(const double *probtab, const int count); 	///<returns random index according to probabilities in the \e probtab table or -1 if all probs are zero. \e count is the number of elements in \e probtab.
 	static bool getMinMaxDef(ParamInterface *p, int propindex, double &mn, double &mx, double &def); ///<perhaps a more useful (higher-level) way to obtain min/max/def info for integer and double properties. Returns true if min/max/def was really available (otherwise it is just invented).
-	static int selectRandomNeuProperty(Neuro* n); ///<selects random property (either 0-based extraproperty of Neuro or 100-based property of its NeuroClass). -1 if Neuro has no properties.
-	static double mutateNeuProperty(double current, Neuro *n, int propindex); ///<returns value \e current mutated for the property \e propindex of NeuroClass \e nc or for extraproperty (\e propindex - 100) of Neuro. Neuro is used as read-only. Give \e propindex == -1 to mutate connection weight (\e nc is then ignored).
+	static int selectRandomNeuronProperty(Neuro* n); ///<selects random property (either 0-based extraproperty of Neuro or NEUROCLASS_PROP_OFFSET-based property of its NeuroClass). -1 if Neuro has no properties.
+	static double mutateNeuronProperty(double current, Neuro *n, int propindex); ///<returns value \e current mutated for the property \e propindex of NeuroClass \e nc or for extraproperty (\e propindex - NEUROCLASS_PROP_OFFSET) of Neuro. Neuro is used as read-only. Give \e propindex == -1 to mutate connection weight (\e nc is then ignored).
 	static bool mutatePropertyNaive(ParamInterface &p, int propindex); ///<creep-mutate selected property. Returns true when success. mutateProperty() should be used instead of this function.
 	static bool mutateProperty(ParamInterface &p, int propindex); ///<like mutatePropertyNaive(), but uses special probability distributions for some neuron properties.
@@ -203,5 +206,5 @@
 	static NeuroClass* parseNeuroClass(char *&s); ///<returns longest matching neuroclass or NULL if the string does not begin with a valid neuroclass name. Advances \e s pointer.
 	static Neuro* findNeuro(const Model *m, const NeuroClass *nc); ///<returns pointer to first Neuro of class \e nc, or NULL if there is no such Neuro.
-	static int neuroClassProp(char *&s, NeuroClass *nc, bool also_v1_N_props = false); ///<returns 0-based property number for \e neuroclass, 100-based extraproperty number for Neuro, or -1 if the string does not begin with a valid property name. Advance \e s pointer if success.
+	static int neuroClassProp(char *&s, NeuroClass *nc, bool also_v1_N_props = false); ///<returns 0-based property number for \e neuroclass, NEUROCLASS_PROP_OFFSET-based extraproperty number for Neuro, or -1 if the string does not begin with a valid property name. Advance \e s pointer if success.
 	static bool isWS(const char c); ///<is \e c a whitespace char?
 	static void skipWS(char *&s); ///<advances pointer \e s skipping whitespaces.